class GueteModellMotor : public Guete
{
    public:
        Integrator*  integrator;
        ModellMotor* modell;
        double *f,*y,*u,t,dt;
        double *ysoll, *usoll;
        int zeitschritte;
        double guete_aktuell;

        GueteModellMotor()
        {
            double wsoll = 100.0;
            modell = new ModellMotor(0.0018,0.00045,0.015,1.0,0.003,wsoll);

            f = new double[modell->yanz()];
            y = new double[modell->yanz()];
            u = new double[modell->uanz()];

            ysoll = new double[modell->yanz()];
            usoll = new double[modell->uanz()];

            integrator = new IntegratorRuku(modell);

            ysoll[0] = modell->wsoll;            
            ysoll[1] = modell->isoll;            
            usoll[0] = modell->usoll;            
        }

        double berechneGuete(double* param)
        {
            zeitschritte = 2000;

            y[0] = 0.0;
            y[1] = 0.0;
            y[2] = 0.0;
            t    = 0.0;
            dt   = 0.001;
            u[0] = 0.0;

            modell->setR(param);
            guete_aktuell = 0.0;               

            for(int i=0;i<2000;i++)
            {
               guete_aktuell += (y[0]-ysoll[0])*(y[0]-ysoll[0])
                              + (y[1]-ysoll[1])*(y[1]-ysoll[1])
                              + 100.0*(u[0]-usoll[0])*(u[0]-usoll[0]);
               integrator->zeitschritt(f,y,u,t,dt);         
               t+=dt;
            }
            return guete_aktuell;                      
        }
};
