#include<fstream>
#include<vector>
#include<string>
#include<iostream>
#include<stdlib.h>

//Hilfsklassen:
#include "Matrix.h"
#include "TextSpeicher.h"
#include "KurvenSpeicher.h"

//Hauptklassen:
#include "Modell.h"
#include "ModellMotor.h"
#include "Integrator.h"
#include "IntegratorRuku.h"

using namespace std;

//Achtung: Innerer Widerstand auf 1Ohm reduziert, 
//         um sinnvolle stationre Spannung zu bekommen.

int main(void)
{
    double t,dt;
    ModellMotor*  modell;
    Integrator* integrator;

    double wsoll = 100.0;  // rad/Sekunde Eine Umdrehung: 2PI
                       // U/min soll 1000 sein.
                       // U/sek = 1000/60
                       // rad/sek = 2*PI*1000/60
                       // ungefhr 100


    modell = new ModellMotor(0.0018,0.00045,0.015,1.0,0.003,wsoll);

    double* y    = new double[modell->yanz()];
    double* u    = new double[1];
    double* f    = new double[modell->yanz()];

    integrator = new IntegratorRuku(modell);

    y[0] = 0.0;
    y[1] = 0.0;
    y[2] = 0.0;
    t    = 0.0;
    dt   = 0.001;

    u[0] = 0.0;


cout<<"r1="<<modell->r1<<endl;
cout<<"r2="<<modell->r2<<endl;
cout<<"wsoll="<<modell->wsoll<<endl;
cout<<"isoll="<<modell->isoll<<endl;
cout<<"usoll="<<modell->usoll<<endl;
//exit(0);

    TextSpeicher kurvenliste("kurvenliste.txt");
    kurvenliste.sammeln("Winkelgeschwindigkeit.txt t/s w/rads-1");
    kurvenliste.sammeln("Strom.txt t/s i/A");
    kurvenliste.sammeln("Spannung.txt t/s u/V");
    kurvenliste.speichern();

    KurvenSpeicher kurve_w("Winkelgeschwindigkeit.txt");
    KurvenSpeicher kurve_i("Strom.txt");
    KurvenSpeicher kurve_u("Spannung.txt");

    for(int i=0;i<2000;i++)
    {
        kurve_w.sammeln(t,y[0]);
        kurve_i.sammeln(t,y[1]);
        kurve_u.sammeln(t,u[0]);
   
        integrator->zeitschritt(f,y,u,t,dt); 
        
        t+=dt;
    }

    kurve_w.speichern();
    kurve_i.speichern();
    kurve_u.speichern();

    system("Plotter.exe");
}
