#include<fstream>
#include<vector>
#include<string>
#include<iostream>
#include<stdlib.h>

//Hilfsklassen:
#include "Matrix.h"
#include "TextSpeicher.h"
#include "KurvenSpeicher.h"

//Hauptklassen:
#include "Modell.h"
#include "ModellMotor.h"
#include "Integrator.h"
#include "IntegratorRuku.h"
#include "Guete.h"
#include "GueteModellMotor.h"
#include "Optimierer.h"
#include "OptimiererParameterstudie.h"

using namespace std;

//Achtung: Innerer Widerstand auf 1Ohm reduziert, 
//         um sinnvolle stationre Spannung zu bekommen.

int main(void)
{
    double param[2];
    double pmin[2] = {-1.0,-1.0};
    double pmax[2] = {1.0,1.0}; //0.7 0.3
//    double pmin[2] = {0.5,0.1};
//    double pmax[2] = {0.9,0.5}; //0.710101 0.326263
//    double pmin[2] = {0.69,0.31}; 
//    double pmax[2] = {0.71,0.33};  //0.71 0.328586
    unsigned long rasterung = 20;

    int panz = 2;

    OptimiererParameterstudie* optimierer;
    Guete*      guete;

    guete = new GueteModellMotor();
    optimierer = new OptimiererParameterstudie(guete,param,pmin,pmax,panz,rasterung);

    optimierer->start();

    pmin[0] = optimierer->parambest[0] - optimierer->parambest[0]*0.05;
    pmin[1] = optimierer->parambest[1] - optimierer->parambest[1]*0.05;
    pmax[0] = optimierer->parambest[0] - optimierer->parambest[0]*0.05;
    pmax[1] = optimierer->parambest[1] - optimierer->parambest[1]*0.05;

    optimierer->start();

    pmin[0] = optimierer->parambest[0] - optimierer->parambest[0]*0.05;
    pmin[1] = optimierer->parambest[1] - optimierer->parambest[1]*0.05;
    pmax[0] = optimierer->parambest[0] - optimierer->parambest[0]*0.05;
    pmax[1] = optimierer->parambest[1] - optimierer->parambest[1]*0.05;
                          
    optimierer->start();

    pmin[0] = optimierer->parambest[0] - optimierer->parambest[0]*0.05;
    pmin[1] = optimierer->parambest[1] - optimierer->parambest[1]*0.05;
    pmax[0] = optimierer->parambest[0] - optimierer->parambest[0]*0.05;
    pmax[1] = optimierer->parambest[1] - optimierer->parambest[1]*0.05;

    optimierer->start();
}
