class IntegratorRuku : public Integrator
{        
    private:
        int i;
        double *k2,*k3,*k4,*yk2,*yk3,*yk4;
    public:
        IntegratorRuku(Modell* modell)
        : Integrator(modell)
        {
            k2 = new double[modell->yanz()];
            k3 = new double[modell->yanz()];
            k4 = new double[modell->yanz()];

            yk2 = new double[modell->yanz()];
            yk3 = new double[modell->yanz()];
            yk4 = new double[modell->yanz()];
        }        

        void zeitschritt(double* f, double* y,double* u, double t, double dt)
        {
//Achtung: Es ist bei den Integrationsverfahren darauf zu achten,
//dass in f wirklich auch die rechte Seite am Ende des Zeitschritts vorliegt.
//Denn die darin reprsentierten Ableitungen der Zustandsgren
//werden z.B. fr den PID-Regler gebraucht!
//deshalb wird hier f statt k1 verwendet.

            modell->rechteSeite(f,y,u,t);

            for(i=0;i<modell->yanz();i++)
                yk2[i] = y[i] + 0.5*dt*f[i];

            modell->rechteSeite(k2,yk2,u,t);

            for(i=0;i<modell->yanz();i++)
                yk3[i] = y[i] + 0.5*dt*k2[i];

            modell->rechteSeite(k3,yk3,u,t);

            for(i=0;i<modell->yanz();i++)
                yk4[i] = y[i] + dt*k3[i];

            modell->rechteSeite(k4,yk4,u,t);

            for(i=0;i<modell->yanz();i++)
                y[i] += (f[i]+2.0*k2[i]+2.0*k3[i]+k4[i])*dt*0.16666666666666666666666666666667;
        }
};
