class OptimiererParameterstudie : public Optimierer
{
    public:
        double* parambest;
        double  guetebest;
        unsigned long rasterung;
        OptimiererParameterstudie(Guete* guete,double* param, 
                                  double* pmin, double* pmax,int panz,
                                  unsigned long rasterung)
        : Optimierer(guete,param,pmin,pmax,panz)
        {
            this->rasterung = rasterung;
            this->parambest = new double[panz];
        }

        virtual void start()
        {
            unsigned long maxlauf   = 1;
            unsigned long durchlauf = 0;
            unsigned long auswahl;
            for(int i=0;i<panz;i++)
                maxlauf*=rasterung;

            double guete_aktuell;

            while(durchlauf<maxlauf)
            {
                cout<<"Versuch Nr."<<(durchlauf+1)<<" von "<<maxlauf<<endl; 

                auswahl = durchlauf;
                for(int i=0;i<panz;i++)
                {
                    param[i] = pmin[i] + ((pmax[i]-pmin[i])*(double)(auswahl%rasterung))/(double)(rasterung-1);
                    auswahl/=rasterung;                                
                }                

                guete_aktuell = guete->berechneGuete(param);
                
                cout<<"Parameterwerte: ";
                for(int i=0;i<panz;i++)
                    cout<<param[i]<<" ";
                cout<<endl;

                cout<<"Aktuell erreichte Guete="<<guete_aktuell<<endl;

                if(durchlauf==0)
                {
                    for(int i=0;i<panz;i++)
                        parambest[i] = param[i];
                    guetebest = guete_aktuell;
                }
                else
                {
                    if(guete_aktuell<guetebest)
                    {
                        for(int i=0;i<panz;i++)
                            parambest[i] = param[i];
                        guetebest = guete_aktuell;
                    }
                }

                durchlauf++;
            }        

            cout<<endl<<"Bestes Ergebnis aus Parameterstudie:"<<endl;
            for(int i=0;i<panz;i++)
            {
                cout<<"Parameter Nr."<<i<<" = "<<parambest[i]<<endl;
            }
            cout<<"Dabei erreichte Guete: "<<guetebest;
        }
};
